#!/usr/bin/perl


require 'config.pl';

$version="2.20";

$title = 'Upload'; 
$title_adm = 'Upload Admin'; 

$infbak = $inf;
$picbak = $picture;
$supbak = $support;

$LOCK_EX = 2;
$LOCK_UN = 8;

use CGI qw/:standard :html3/;
use CGI::Carp;

$q = new CGI;

$referer = $ENV{HTTP_REFERER};

if(!$upload_form) {$upload_form = $referer;}

if(param('head') eq "0") {$header = ""; $footer = "";}

&Get_Types();
&Admin if     (param('action')  eq 'admin');
&Download if  (param('action')  eq 'download');
&Modify if    (param('action')  eq 'modify');
&Modify2 if   (param('action2') eq 'modify2');
&Modify3 if   (param('action2') eq 'modify3');
&Makedirs if  (param('action')  eq 'makedir');
&Makedirs2 if (param('action2') eq 'makedir2');
&Remove if    (param('action')  eq 'remove');
&Remove2 if   (param('action2') eq 'remove2');
&Password if  (param('action')  eq 'password');
&Password2 if (param('action2') eq 'password2');
&Upload if    (param('action')  eq 'upload');
&Upload2 if   (param('action2') eq 'upload2');
&Search if    (param('action')  eq 'search');
&Search2 if   (param('action2') eq 'search2');
&Top if       (param('action')  eq 'toplist');
&Stats if     (param('action')  eq 'stats');

&Upview;
exit;

sub Get_Types {
  foreach(@types) {
    ($dir,$name) = split("#");
    $TYPE{lc($dir)} = $name;
  }
  $TYPE{'search'} = "Search";
  $TYPE{'newfiles'} = "New Downloads";
  $TYPE{'toplist'} = "TOP";
}

sub Stats {
  open(FILE,"<$datafile") || &Error("Error opening file $datafile");
  &lock(FILE);
    @database = <FILE>;
  &unlock(FILE);
  close(FILE);

  $counter=0;$downloads=0;$total_size=0;
  foreach(@database) {
    chomp();
    my ($foo,$id,$date,$name,$type,$filename,$size,$author,$email,$description,$count,$info,$pic,$sup) = split('\|\|');
    $counter++;
    $downloads += $count;
    if($size =~ "K") {
        $size =~ s/K//g;
        $total_size += ($size * 1024);
    } elsif($size =~ "M") {
        $size =~ s/M//g;
        $total_size += ($size * 1048576);
    } elsif($size =~ "G") {
        $size =~ s/G//g;
        $total_size += ($size * 1073741824);
    } elsif($size =~ "T") {
        $size =~ s/T//g;
        $total_size += ($size * 1099511627776);
    }
  }

  while ($total_size > 1024 and $length_descriptor ne 'T')
  {
    $total_size /= 1024;
    $length_descriptor = ($length_descriptor ? ($length_descriptor eq 'K'
      ? 'M' : $length_descriptor eq 'M' ? 'G' : 'T' ) : 'K');
  }

  $total_size = sprintf("%.2f",$total_size);

print "Content-type: text/html\n\n";
&header;
print "<br><font face=\"Verdana, Arial\" size=\"2\"><b>Dateien gesamt:</b> $counter\n";
print "<br><b>Belegter Speicherplatz gesamt:</b> $total_size$length_descriptor\n";
print "<br><b>Downloads insgesamt:</b> $downloads</font>\n";
&footer;
exit
}

#############################
# Topdownloads
#####################
sub Top {
  if(param('count')) { $topcount = param('count'); }  
  else { $topcount = 20; }
  if(param('tmpl')) { $file_template = param('tmpl');}

  open(FILE,"<$datafile") || &Error("Error opening file $datafile");
  &lock(FILE);
    @database = <FILE>;
  &unlock(FILE);
  close(FILE);

  open(FILE,"<$cgidir/$file_template") || &Error("Error opening file $file_template");
  &lock(FILE);
	@template = <FILE>;
  &unlock(FILE);
  close(FILE);

  @table = @template;

  @toplist = sort {@x = split('\|\|',$a);@y = split('\|\|',$b);($y[10] <=> $x[10]);} @database;
  splice(@toplist, $topcount);
  $counter=0;
  foreach(@toplist) {
      my ($foo,$id,$date,$name,$type,$filename,$size,$author,$email,$description,$count,$info,$pic,$sup);
      chomp;
      ($foo,$id,$date,$name,$type,$filename,$size,$author,$email,$description,$count,$info,$pic,$sup) = split('\|\|');

      $counter++;

      if ($count eq '') { $count = '0';}

      if ($info ne '' ) {
          $inf =~ s/URL/${up_rooturl}\/${type}\/${info}/g;
          $in = $inf;
          $inf = $infbak;
      } else { $in = $noinf; }

      if ($pic ne '' ) {
          $picture =~ s/URL/${up_rooturl}\/${type}\/${pic}/g;
          $p = $picture;
          $picture = $picbak;
      } else { $p = $nopicture; }


      if ($sup ne '' ) {
          $support =~ s/URL/${sup}/g;
          $s = $support;
          $support = $supbak;
      } else { $s = $nosup; }

      $string2 = "<STRONG>$string</STRONG>";
      $description =~ s/${string}/${string2}/g;

      
      for ($i=0; $i<@table; $i++) {
          $table[$i] =~ s/<!-- updir -->/$up_rooturl/g;
          $table[$i] =~ s/<!-- cgi -->/$cgiurl/g;
          $table[$i] =~ s/<!-- filename -->/$filename/g;
          $table[$i] =~ s/<!-- name -->/$name/g;
          $table[$i] =~ s/<!-- size -->/$size/g;
          $table[$i] =~ s/<!-- description -->/$description/g;
          $table[$i] =~ s/<!-- author -->/$author/g;
          $table[$i] =~ s/<!-- email -->/$email/g;
          $table[$i] =~ s/<!-- date -->/$date/g;
          $table[$i] =~ s/<!-- count -->/$count/g;
          $table[$i] =~ s/<!-- position -->/$counter/g;
          $table[$i] =~ s/<!-- type -->/$type/g;
          $table[$i] =~ s/<!-- id -->/$id/g;
          $table[$i] =~ s/<!-- info -->/$in/g;
          $table[$i] =~ s/<!-- pic -->/$p/g;
          $table[$i] =~ s/<!-- support -->/$s/g;
      }
      $result .= "@table";
      @table = @template;
  }

  if ($counter < $topcount) { $topcount = $counter; }

print "Content-type: text/html\n\n";
if($header) {
open(FILE,"<$header") || &Error("$header not found!");
&lock(FILE);
@header = <FILE>;
&unlock(FILE);
close(FILE);
    
$plah = "$TYPE{'toplist'}$topcount";
for($i=0;$i<@header;$i++) {
$header[$i] =~ s/<!-- type -->/$plah/g;
}

print @header;
  }
  if(param('filecount') ne '0') {
    print "<CENTER><font face=verdana size=2><b>Top $topcount Downloads</b></font><br>\n";
  }

  print "$result";


  
  print "</CENTER>";

if($footer) {
open(FILE,"<$footer") || &Error("$footer not found!");
&lock(FILE);
@footer = <FILE>;
&unlock(FILE);
close(FILE);
print @footer;
}
exit;
}


###########################################
# Suche
###########################################
sub Search {
  print "Content-type: text/html\n\n";
  if($header) {
    open(FILE,"<$header") || &Error("$header not found!");
    &lock(FILE);
      @header = <FILE>;
    &unlock(FILE);
    close(FILE);
    for($i=0;$i<@header;$i++) {
      $header[$i] =~ s/<!-- type -->/$TYPE{'search'}/g;
    }

    print @header;
  } else {
    print "\n";
  }

  print "<FONT FACE='Verdana' SIZE='2'>\n";
  print "<CENTER><b>Suche nach Dateien</b><br><br>\n";
  print "<FORM METHOD=POST ACTION=\"$cgiurl?action=search2\">\n";
  print "<INPUT TYPE=hidden name=\"action2\" value=\"search2\">\n";
  print "<INPUT NAME=\"search_string\" SIZE=10>";
  print "<INPUT TYPE=submit NAME=submit VALUE=\"Suchen\"\n";
  print "</FORM><br>\n";
  
  print "</CENTER></FONT>\n";
  if($footer) {
    open(FILE,"<$footer") || &Error("$footer not found!");
    &lock(FILE);
      @footer = <FILE>;
    &unlock(FILE);
    close(FILE);
    print @footer;
  }

  exit;
}

sub Search2 {
  $string = param('search_string');
  $counter = 0;

  open(FILE,"<$datafile") || &Error("Error opening file $datafile");
  &lock(FILE);
    @database = <FILE>;
  &unlock(FILE);
  close(FILE);

  open(FILE,"<$cgidir/$file_template") || &Error("Error opening file $file_template");
  &lock(FILE);
	@template = <FILE>;
  &unlock(FILE);
  close(FILE);

  @table = @template;


  print "Content-type: text/html\n\n";
  if($header) {
    open(FILE,"<$header") || &Error("$header not found!");
    &lock(FILE);
      @header = <FILE>;
    &unlock(FILE);
    close(FILE);
    for($i=0;$i<@header;$i++) {
      $header[$i] =~ s/<!-- type -->/$TYPE{'search'}/g;
    }

    print @header;
  } else {
    print "\n";
  }

  print "<font face='Verdana' size='2'><b>Suchresultate:</b></font>\n";
  print "\n";

  foreach (@database) {
    chomp;
    ($foo,$id,$date,$name,$type,$filename,$size,$author,$email,$description,$count,$info,$pic,$sup) = split('\|\|');
    if (($description =~/\b$string/i) || ($string =~ /\b$description/i)) {

      $counter++;

      if ($count eq '') { $count = '0';}

      if ($info ne '' ) {
          $inf =~ s/URL/${up_rooturl}\/${type}\/${info}/g;
          $in = $inf;
          $inf = $infbak;
      } else { $in = $noinf; }

      if ($pic ne '' ) {
          $picture =~ s/URL/${up_rooturl}\/${type}\/${pic}/g;
          $p = $picture;
          $picture = $picbak;
      } else { $p = $nopicture; }

      if ($sup ne '' ) {
          $support =~ s/URL/${sup}/g;
          $s = $support;
          $support = $supbak;
      } else { $s = $nosup; }


        $string2 = "<STRONG>$string</STRONG>";
        $description =~ s/${string}/${string2}/g;

	for ($i=0; $i<@table; $i++) {
          $table[$i] =~ s/<!-- updir -->/$up_rooturl/g;
          $table[$i] =~ s/<!-- cgi -->/$cgiurl/g;
          $table[$i] =~ s/<!-- filename -->/$filename/g;
          $table[$i] =~ s/<!-- name -->/$name/g;
          $table[$i] =~ s/<!-- size -->/$size/g;
          $table[$i] =~ s/<!-- description -->/$description/g;
          $table[$i] =~ s/<!-- author -->/$author/g;
          $table[$i] =~ s/<!-- email -->/$email/g;
          $table[$i] =~ s/<!-- date -->/$date/g;
          $table[$i] =~ s/<!-- count -->/$count/g;
          $table[$i] =~ s/<!-- type -->/$type/g;
          $table[$i] =~ s/<!-- id -->/$id/g;
          $table[$i] =~ s/<!-- info -->/$in/g;
          $table[$i] =~ s/<!-- pic -->/$p/g;
          $table[$i] =~ s/<!-- support -->/$s/g;
	}
        $result .= "@table";
	@table = @template;

    }
  }
  print "<FONT face=\Verdana, Arial size=\"2\"><CENTER>\n";
  print "<B>$counter</B> Datei(en) zu Suchbegriff  <B>$string</B> gefunden.";
  print $result;
  
  print "</CENTER></FONT>\n";
  if($footer) {
    open(FILE,"<$footer") || &Error("$footer not found!");
    &lock(FILE);
      @footer = <FILE>;
    &unlock(FILE);
    close(FILE);
    print @footer;
  }

  exit;
}
###########################################
# Admin 
###########################################
sub Admin {
  print "Content-type: text/html\n\n";
&header;
  print "<CENTER><font face=\"Verdana, Arial\" size=\"2\"><b>Administration</b><hr width=50% height=2>\n";
  print "<A HREF='$cgiurl?action=makedir'>Verzeichnisse anlegen</A><BR>\n";
  print "<A HREF='$cgiurl?action=remove'>Dateien lschen</A><BR>\n";
  print "<A HREF='$cgiurl?action=modify'>Dateien ndern</A><BR>\n";
  print "<HR WIDTH=10%>\n";
  print "<A HREF='$cgiurl?action=password'>Passwort ndern</A></font><P>\n";
  
  print "</CENTER>\n";
  &footer;
  exit;
}

################################
# File viewer
################################
sub Upview {
  $counter = 0;
  $param_type = param('type');
  if(param('tmpl')) { $file_template = param('tmpl');}
  if(param('count')) { $newcount = param('count'); }  
  else { $newcount = 10; }

  if ($param_type eq '') {$param_type='newfiles';}

  open(FILE,"<$datafile") || &Error("Error opening $datafile");
  &lock(FILE);
    @database = <FILE>;
  &unlock(FILE);
  close(FILE);

  open(FILE,"<$cgidir/$file_template");
  &lock(FILE);
	@template = <FILE>;
  &unlock(FILE);
  close(FILE);

  @table = @template;

  if ($param_type eq 'newfiles') {
    splice(@database,$newcount);
  } elsif ($param_type ne 'all') {
    for ($i=0; $i<@database; $i++) {
      ($foo,$id,$date,$name,$type,$filename,$size,$author,$email,$description,$count,$info,$pic,$sup) = split('\|\|',$database[$i]);
      if ($param_type ne $type) {
        splice(@database, $i, 1);
        $i--;
      }
    }
  }

  foreach (@database) {
    my ($foo,$id,$date,$name,$type,$filename,$size,$author,$email,$description,$count,$info,$pic,$sup);
    chomp;
    ($foo,$id,$date,$name,$type,$filename,$size,$author,$email,$description,$count,$info,$pic,$sup) = split('\|\|');

    if ($count eq '') { $count = '0';}

    if ($info ne '' ) {
        $inf =~ s/URL/${up_rooturl}\/${type}\/${info}/g;
        $in = $inf;
        $inf = $infbak;
    } else { $in = $noinf; }

    if ($pic ne '' ) {
        $picture =~ s/URL/${up_rooturl}\/${type}\/${pic}/g;
        $p = $picture;
        $picture = $picbak;
    } else { $p = $nopicture; }

    if ($sup ne '' ) {
        $support =~ s/URL/${sup}/g;
        $s = $support;
        $support = $supbak;
    } else { $s = $nosup; }


    $counter++;


	for ($i=0; $i<@table; $i++) {
          $table[$i] =~ s/<!-- updir -->/$up_rooturl/g;
          $table[$i] =~ s/<!-- cgi -->/$cgiurl/g;
	  $table[$i] =~ s/<!-- filename -->/$filename/g;
	  $table[$i] =~ s/<!-- name -->/$name/g;
	  $table[$i] =~ s/<!-- size -->/$size/g;
	  $table[$i] =~ s/<!-- description -->/$description/g;
	  $table[$i] =~ s/<!-- author -->/$author/g;
	  $table[$i] =~ s/<!-- email -->/$email/g;
	  $table[$i] =~ s/<!-- date -->/$date/g;
	  $table[$i] =~ s/<!-- count -->/$count/g;
	  $table[$i] =~ s/<!-- type -->/$type/g;
	  $table[$i] =~ s/<!-- id -->/$id/g;
          $table[$i] =~ s/<!-- info -->/$in/g;
          $table[$i] =~ s/<!-- pic -->/$p/g;
          $table[$i] =~ s/<!-- support -->/$s/g;          
	}
        $result .= "@table\n";
	@table = @template;
  }

  print "Content-type: text/html\n\n";

  if($header) {
    open(FILE,"<$header") || &Error("$header not found!");
    &lock(FILE);
      @header = <FILE>;
    &unlock(FILE);
    close(FILE);
    $param_type = lc($param_type);
    for($i=0;$i<@header;$i++) {
      $header[$i] =~ s/<!-- type -->/$TYPE{$param_type}/g;
    }
    print @header;
  } 


  print "<FONT FACE='Verdana' COLOR='#000000' SIZE='2'><CENTER>\n";
  if(!param('filecount') ne '0') {
    print "Es sind <B>$counter</B> Dateien in der Datenbank.";
  }
  print "$result\n";
  
  print "</FONT>\n";
  if($footer) {
    open(FILE,"<$footer") || &Error("$footer not found!");
    &lock(FILE);
      @footer = <FILE>;
    &unlock(FILE);
    close(FILE);
    print @footer;
  }
  exit;

}

################################
# Downloadaus
################################
sub Download {
  $param_type = param('type');
  ($param_id) = param('id') =~ /([0-9]*)/;
  $param_file = param('filename');

&Error('Error in File-ID') unless($param_id);

open(FILE, "<$datafile") || &Error("Error opening $datafile");
&lock(FILE);
@database = <FILE>;
&unlock(FILE);
close(FILE);

for($i=0;$i<@database;$i++) {
    ($foo,$fid,$date,$name,$type,$filename,$size,$author,$email,$description,$count,$info,$pic,$sup) = split('\|\|', $database[$i]);
    chomp($sup);
    $string .= "'$fid' - '$param_id'<br>";
    if(($fid == $param_id) || ("$fid" eq "$param_id")) {
      if(!$count) {$count=0;}
      $count++;
      $data_string = join('||',($foo,$fid,$date,$name,$type,$filename,$size,$author,$email,$description,$count,$info,$pic,$sup));
      splice(@database, $i, 1, $data_string."\n");
      $param_type=$type;
      $param_file=$filename;
      $found = 1;
      last;
    }
  }
  if(!$found) {&Error("File-ID $param_id not found");}
  if(param('debug')) {&Error("$string");}

  open(FILE, ">$datafile") || &Error("Error writing $datafile");
   &lock(FILE);
   print FILE @database;
   &unlock(FILE);
  close(FILE);


 
  $file = "$up_rooturl/$param_type/$param_file";

  print "Content-type: text/html\n";
  print "Location: $file\n\n";
  exit;
}

################################
# Dateien ndern
################################
sub Modify {

  $download = "$cgiurl?action=download";
  open (FILE, "$datafile") || &Error("Error opening $datafile");
   &lock(FILE);
   @database = <FILE>;
   &unlock(FILE);
  close(FILE);

  print "Content-type: text/html\n\n";
&header;
  print "<CENTER><font face=\"Verdana, Arial\" size=\"2\"><b>Administration - Dateien ndern</b></font>\n";
  print "<hr width=50% height=2>\n";

  print "<form action='$cgiurl?action=modify2' method=post>\n";
  print "<INPUT TYPE=hidden name=\"action2\" value=\"modify2\">\n";
  print "<table border=0 cellpadding=2 width=600>\n";
  print "<tr><td><input type=submit name=submit value=\"Datei ndern\"></td><td><font face=\"Verdana, Arial\" size=\"2\">Passwort:</font> <input type='password' name=pass size=20></td></tr>\n";

  foreach (@database) {
    my ($foo,$id,$date,$name,$type,$filename,$size,$author,$email,$description,$count,$info,$pic);
    chomp;
    ($foo,$id,$date,$name,$type,$filename,$size,$author,$email,$description,$count,$info,$pic,$sup) = split('\|\|');

    if ($count == '') { $count = '0';}

    if ($info ne '' ) {
        $inf =~ s/URL/${up_rooturl}\/${type}\/${info}/g;
        $in = $inf;
        $inf = $infbak;
    } else { $in = $noinf; }

    if ($pic ne '' ) {
        $picture =~ s/URL/${up_rooturl}\/${type}\/${pic}/g;
        $p = $picture;
        $picture = $picbak;
    } else { $p = $nopicture; }

    if ($sup ne '' ) {
        $support =~ s/URL/${sup}/g;
        $s = $support;
        $support = $supbak;
    } else { $s = $nosup; }


    print "<TR>\n";
    print "<TD ALIGN=center><input type=radio name=mod value=\"$id\"></TD>\n";
    print "<TD><TABLE BORDER=\"1\" CELLPADDING=\"0\" CELLSPACING=\"0\" WIDTH=\"510\"><TR>\n";
    print "<TD WIDTH=\"76\" BGCOLOR=\"#514770\"><P ALIGN=\"CENTER\"><B><FONT SIZE=\"1\" COLOR=\"white\" FACE=\"Arial\">Datum</FONT></B></TD>\n";
    print "<TD WIDTH=\"200\" BGCOLOR=\"#514770\"><P ALIGN=\"CENTER\"><B><FONT SIZE=\"1\" COLOR=\"white\" FACE=\"Arial\">Datei</FONT></B></TD>\n";
    print "<TD WIDTH=\"51\" BGCOLOR=\"#514770\"><P ALIGN=\"CENTER\"><B><FONT SIZE=\"1\" COLOR=\"white\" FACE=\"Arial\">Gre</FONT></B></TD>\n";
    print "<TD WIDTH=\"67\" BGCOLOR=\"#514770\"><P ALIGN=\"CENTER\"><B><FONT SIZE=\"1\" COLOR=\"white\" FACE=\"Arial\">Autor</FONT></B></TD>\n";
    print "<TD WIDTH=\"40\"  BGCOLOR=\"#514770\"><P ALIGN=\"CENTER\"><B><FONT SIZE=\"1\" COLOR=\"white\" FACE=\"Arial\">Info</FONT></B></TD></TR>\n";
    print "<TR>\n";
    print "<TD WIDTH=\"76\"><CENTER><FONT SIZE=\"1\" FACE=\"Arial\">$date</FONT></TD>\n";
    print "<TD WIDTH=\"200\"><CENTER><A HREF=\"$download&type=$type&filename=$filename&id=$id\"><FONT SIZE=\"1\" FACE=\"Arial\">$name</FONT></A></TD>\n";
    print "<TD WIDTH=\"51\"><CENTER><FONT SIZE=\"1\" FACE=\"Arial\">$size</FONT></TD>\n";
    print "<TD WIDTH=\"67\"><CENTER><FONT SIZE=\"1\" FACE=\"Arial\"></FONT></A><A HREF=\"mailto:$email\"><FONT SIZE=\"1\" FACE=\"Arial\">$author</FONT></A></TD>\n";
    print "<TD WIDTH=\"40\"> <P ALIGN=\"CENTER\">$p&nbsp;$in&nbsp;$s</TD></TR><TR>\n";
    print "<TD WIDTH=\"76\" BGCOLOR=\"#514770\"><P ALIGN=\"CENTER\"><B><FONT SIZE=\"1\" COLOR=\"white\" FACE=\"Arial\">Beschreibung:</FONT></B> </TD>\n";
    print "<TD COLSPAN=\"3\" BGCOLOR=\"#F0F0F0\" ><FONT SIZE=\"1\" FACE=\"Arial\">&nbsp;$description</FONT></TD><TD WIDTH=\"15\" BGCOLOR=\"#F0F0F0\" ><FONT SIZE=\"1\" FACE=\"Arial\">DL:$count</FONT></TD> </TR></TABLE></TD></TR>\n\n\n\n\n\n";
  }
  print "</TD></TR></TABLE>";
  
  print "</SPAN>\n";
&footer;
  exit;
}


sub Modify2 {
  &Checkpass;

  $fileid = param('mod');

  open (FILE, "$datafile") || &Error("Error opening $datafile");
   &lock(FILE);
   @database = <FILE>;
   &unlock(FILE);
  close(FILE);

  print "Content-type: text/html\n\n";
&header;
  print "<CENTER><font face=\"Verdana, Arial\" size=\"2\"><b>Administration - Dateien editieren</b>\n";
  print "<hr width=50% height=2>\n";
  print "<FORM ACTION='$cgiurl?action=modify3' METHOD=POST>\n";
  print "<INPUT TYPE=hidden name=\"action2\" value=\"modify3\">\n";
  print "<TABLE BORDER='1' CELLPADDING='0' CELLSPACING='0' WIDTH='510'><TR>\n";
  print "<TD WIDTH='76' BGCOLOR='#514770'><P ALIGN='CENTER'><B><FONT SIZE='1' COLOR='white' FACE='Arial'>Datum</FONT></B></TD>\n";
  print "<TD WIDTH='200' BGCOLOR='#514770'><P ALIGN='CENTER'><B><FONT SIZE='1' COLOR='white' FACE='Arial'>Datei</FONT></B></TD>\n";
  print "<TD WIDTH='168' BGCOLOR='#514770'><P ALIGN='CENTER'><B><FONT SIZE='1' COLOR='white' FACE='Arial'>Autor</FONT></B></TD>\n";
  print "<TD WIDTH='15'  BGCOLOR='#514770'><P ALIGN='CENTER'><B><FONT SIZE='1' COLOR='white' FACE='Arial'>Info</FONT></B></TD></TR>\n";
  print "<TR>\n"; #/

  foreach (@database) {
    ($foo,$id,$date,$name,$type,$filename,$size,$author,$email,$description,$count,$info,$pic,$sup) = split('\|\|');
    last if $id eq $fileid;
  }
  print "<TD WIDTH='76'><CENTER><font face=\"Verdana, Arial\" size=\"2\">Datum:<br>     <INPUT TYPE=text name=mod_date VALUE='$date'></TD>\n";
  print "<TD WIDTH='200'><CENTER><font face=\"Verdana, Arial\" size=\"2\">Name:<br>          <INPUT TYPE=text name=mod_name VALUE='$name'><br>Dateiname:<br><INPUT TYPE=text name=mod_filename VALUE='$filename'><INPUT TYPE=hidden name=mod_filenameorg VALUE='$filename'><br>Dateiverzeichnis:<br><INPUT TYPE=text name=mod_type VALUE='$type'><INPUT TYPE=hidden name=mod_typeorg VALUE='$type'></TD>\n";
  print "<TD WIDTH='168'><CENTER><font face=\"Verdana, Arial\" size=\"2\">E-Mail:<br>         <INPUT TYPE=text name=mod_email VALUE='$email'><br>Autor:<br> <INPUT TYPE=text name=mod_author VALUE='$author'></TD>\n";
  print "<TD WIDTH='15'><P ALIGN='CENTER'><font face=\"Verdana, Arial\" size=\"2\">Info:<br> <INPUT TYPE=text name=mod_info VALUE='$info'><INPUT TYPE=hidden name=mod_infoorg VALUE='$info'><BR>Screenshot:<br> <INPUT TYPE=text name=mod_pic VALUE='$pic'><INPUT TYPE=hidden name=mod_picorg VALUE='$pic'><br>ServiceURL:<br> <INPUT TYPE=text name=\"modsup\" VALUE='$sup'>\n";
  print "</TD></TR><TR>\n";
  print "<TD WIDTH='76' BGCOLOR='#514770'><P ALIGN='CENTER'><B><FONT SIZE='1' COLOR='white' FACE='Arial'>Beschreibung:</FONT></B> </TD>\n";
  print "<TD COLSPAN='3' BGCOLOR='#F0F0F0' ><INPUT TYPE=text name=mod_description size=50 VALUE='$description'></TD></TR></TABLE><BR>\n";
  print "<INPUT TYPE=hidden NAME=fileid VALUE='$id'><INPUT TYPE=hidden NAME=count VALUE='$count'>\n";


  print "<BR><INPUT TYPE=submit NAME=submit VALUE=\"Eintrag ndern\"><INPUT TYPE=reset VALUE=\"Abbrechen\">\n";
  print "</FORM>\n";
  
  print "</SPAN>\n";
  &footer;
  exit;
}

sub Modify3 {

  $fileid =     param('fileid');
  $filedate =   param('mod_date');
  $file_filename = param('mod_filename');
  $file_filenameorg = param('mod_filenameorg');
  $file_name =  param('mod_name');
  $filetype =   param('mod_type');
  $filetypeorg = param('mod_typeorg');
  $fileemail =  param('mod_email');
  $fileauthor = param('mod_author');
  $fileinfo = param('mod_info');
  $fileinfoorg = param('mod_infoorg');
  $filepic =    param('mod_pic');
  $filepicorg = param('mod_picorg');
  $filedesc =   param('mod_description');
  $filesup = param('modsup');
  #$suporg = param('mod_suporg');

  if ($filetype ne $filetypeorg) {
    if (-e "$up_rootdir/$filetype/$file_filename") { &Error("Datei $filetype/$file_filename existiert bereits ");}
    system("mv -f $up_rootdir/$filetypeorg/$file_filename $up_rootdir/$filetype/$file_filename");
    if ($fileinfo) {
      if (-e "$up_rootdir/$filetype/$fileinfo") { &Error("Datei $filetype/$fileinfo existiert bereits ");}
      system("mv -f $up_rootdir/$filetypeorg/$fileinfo $up_rootdir/$filetype/$fileinfo");
    }
  }

  if ($fileinfo ne $fileinfoorg) {
    if ($fileinfo eq '') {
    system("rm -f $up_rootdir/$filetypeorg/$fileinfoorg"); }
    if (-e "$up_rootdir/$filetype/$fileinfo") { &Error("Datei $filetype/$fileinfo existiert bereits ");}
    system("mv -f $up_rootdir/$filetypeorg/$fileinfoorg $up_rootdir/$filetype/$fileinfo");
  }
  
  

  open (FILE, "$datafile") || &Error("Error opening $datafile");
   &lock(FILE);
   @database = <FILE>;
   &unlock(FILE);
  close(FILE);

  for ($i=0; $i<@database; $i++) {
    ($foo,$id,$date,$name,$type,$filename,$size,$author,$email,$description,$count,$info,$pic,$sup) = split('\|\|', $database[$i]);
    if ($id eq $fileid) {
      $data_string = "\|\|$id\|\|$filedate\|\|$file_name\|\|$filetype\|\|$file_filename\|\|$size\|\|$fileauthor\|\|$fileemail\|\|$filedesc\|\|$count\|\|$fileinfo\|\|$filepic\|\|$filesup\|\|\n";
      splice(@database, $i, 1, $data_string);
      last;
    }
  }

  open (FILE, ">$datafile") || &Error("Error opening $datafile");
   &lock(FILE);
   print FILE @database;
   &unlock(FILE);
  close(FILE);

  print "Content-type: text/html\n\n";
  print "<HTML>\n";
  print "<HEAD><TITLE>Administration - nderungen gespeichert</TITLE>\n";
    print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"5;URL=$cgiurl?action=modify\"></HEAD>\n";
  print "<BODY BGCOLOR='#FFFFFF'>\n";
  print "<CENTER><font face=\"Verdana, Arial\" size=\"2\"><b>Administration - nderungen gespeichert</b>\n";
  print "\n";
  if ($filetype ne $filetypeorg) {
    print "$filetypeorg/$file_filenameorg ==&gt; ";
    print "$filetype/$file_filename<br>\n";
  }
  if ($fileinfo ne $fileinfoorg) {
    print "$filetypeorg/$fileinfoorg ==&gt; ";
    print "$filetype/$fileinfo<br>\n\n";
  }
  
  print "...Einen Moment bitte, Sie werden gleich weitergeleitet.</SPAN>\n";
  &footer;
  exit;
}

################################
# Dateien lschen
################################
sub Remove {
  $download = "$cgiurl?action=download";
  open (FILE, "$datafile") || &Error("Error opening $datafile");
   &lock(FILE);
   @database = <FILE>;
   &unlock(FILE);
  close(FILE);

  print "Content-type: text/html\n\n";
&header;
  print "<CENTER><font face=\"Verdana, Arial\" size=\"2\"><b>Administration - Dateien lschen</b></font>\n";
  print "<hr width=50% height=2>\n";

  print "<form action='$cgiurl?action=remove2' method=post>\n";
  print "<INPUT TYPE=hidden name=\"action2\" value=\"remove2\">\n";
  print "<table border=0 cellpadding=2 width=600>\n";
  print "<tr><td><input type=submit name=submit value=\"Datei lschen\"></td><td><font face=\"Verdana, Arial\" size=\"2\">Passwort:</font> <input type='password' name=pass size=20></td></tr>\n";

  foreach (@database) {
    my ($foo,$id,$date,$name,$type,$filename,$size,$author,$email,$description,$count,$info,$pic);
    chomp;
    ($foo,$id,$date,$name,$type,$filename,$size,$author,$email,$description,$count,$info,$pic,$sup) = split('\|\|');
	$position = rindex($id, " ") + 1;
	$id = substr($id, $position);

    if ($count == '') { $count = '0';}

    if ($info ne '' ) {
        $inf =~ s/URL/$up_rooturl\/$type\/$info/g;
        $in = $inf;
        $inf = $infbak;
    } else { $in = $noinf; }

    if ($pic ne '' ) {
        $picture =~ s/URL/$up_rooturl\/$type\/$pic/g;
        $p = $picture;
        $picture = $picbak;
    } else { $p = $nopicture; }

    if ($sup ne '' ) {
        $support =~ s/URL/$sup/g;
        $s = $support;
        $support = $supbak;
    } else { $s = $nosup; }


    print "<TR>\n";
    print "<TD ALIGN=center><input type=checkbox name=\"$id\" value=\"1\"></TD>\n";
    print "<TD><TABLE BORDER=\"1\" CELLPADDING=\"0\" CELLSPACING=\"0\" WIDTH=\"510\"><TR>\n";
    print "<TD WIDTH=\"76\" BGCOLOR=\"#514770\"><P ALIGN=\"CENTER\"><B><FONT SIZE=\"1\" COLOR=\"white\" FACE=\"Arial\">Datum</FONT></B></TD>\n";
    print "<TD WIDTH=\"200\" BGCOLOR=\"#514770\"><P ALIGN=\"CENTER\"><B><FONT SIZE=\"1\" COLOR=\"white\" FACE=\"Arial\">Datei</FONT></B></TD>\n";
    print "<TD WIDTH=\"51\" BGCOLOR=\"#514770\"><P ALIGN=\"CENTER\"><B><FONT SIZE=\"1\" COLOR=\"white\" FACE=\"Arial\">Gre</FONT></B></TD>\n";
    print "<TD WIDTH=\"67\" BGCOLOR=\"#514770\"><P ALIGN=\"CENTER\"><B><FONT SIZE=\"1\" COLOR=\"white\" FACE=\"Arial\">Autor</FONT></B></TD>\n";
    print "<TD WIDTH=\"40\"  BGCOLOR=\"#514770\"><P ALIGN=\"CENTER\"><B><FONT SIZE=\"1\" COLOR=\"white\" FACE=\"Arial\">Info</FONT></B></TD></TR>\n";
    print "<TR>\n";
    print "<TD WIDTH=\"76\"><CENTER><FONT SIZE=\"1\" FACE=\"Arial\">$date</FONT></TD>\n";
    print "<TD WIDTH=\"200\"><CENTER><A HREF=\"$download&type=$type&filename=$filename&id=$id\"><FONT SIZE=\"1\" FACE=\"Arial\">$name</FONT></A></TD>\n";
    print "<TD WIDTH=\"51\"><CENTER><FONT SIZE=\"1\" FACE=\"Arial\">$size</FONT></TD>\n";
    print "<TD WIDTH=\"67\"><CENTER><FONT SIZE=\"1\" FACE=\"Arial\"></FONT></A><A HREF=\"mailto:$email\"><FONT SIZE=\"1\" FACE=\"Arial\">$author</FONT></A></TD>\n";
    print "<TD WIDTH=\"40\"> <P ALIGN=\"CENTER\">$p&nbsp;$in</TD></TR><TR>\n";
    print "<TD WIDTH=\"76\" BGCOLOR=\"#514770\"><P ALIGN=\"CENTER\"><B><FONT SIZE=\"1\" COLOR=\"white\" FACE=\"Arial\">Beschreibung:</FONT></B> </TD>\n";
    print "<TD COLSPAN=\"3\" BGCOLOR=\"#F0F0F0\" ><FONT SIZE=\"1\" FACE=\"Arial\">&nbsp;$description</FONT></TD><TD WIDTH=\"15\" nowrap BGCOLOR=\"#F0F0F0\" ><FONT SIZE=\"1\" FACE=\"Arial\">DL:$count</FONT></TD> </TR></TABLE></TD></TR>\n\n\n\n\n\n";
  }
  print "</TD></TR></TABLE>";
  
  print "</SPAN>\n";
  &footer;
  exit;
}

sub Remove2 {
  &Checkpass;

  open (FILE, "$datafile") || &Error("Error opening $datafile");
    &lock(FILE);
    @database = <FILE>;
    &unlock(FILE);
  close(FILE);

  for ($i=0; $i<@database; $i++) {
    ($foo,$id,$date,$name,$type,$filename,$size,$author,$email,$description,$count,$info,$pic,$sup) = split('\|\|',$database[$i]);
    #if ($id eq $fileid) {
    #$removed .= param($id) . "<br>";
    if(param($id)) {
      $dir = "$up_rootdir/$type";
      unlink("$dir/$filename"); # Erase the file
      unlink("$dir/$pic");      # Erase picturefile
      unlink("$dir/$info");
      splice(@database, $i, 1);       # Erase the file from the database
      $removed .= "$dir/$filename<BR>\n";
      $i--;
    }
  }

  open (FILE, ">$datafile") || &Error("Error opening $datafile");
    &lock(FILE);
    print FILE @database;
    &unlock(FILE);
  close(FILE);

  print "Content-type: text/html\n\n";
  print "<HTML>\n";
  print "<HEAD><TITLE>$title_adm - Remove</TITLE>\n";
  print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"5;URL=$cgiurl?action=remove\"></HEAD>\n";
  print "<BODY BGCOLOR='#FFFFFF'>\n";
  print "<CENTER><b><font face=\"Verdana, Arial\" size=\"2\">Administration - Dateien lschen</b>\n";
  print "Dateien gelscht";
  print "$removed";
  
  print "<br>... bitte einen Moment warten, Sie werden weitergeleitet</SPAN>\n";
  &footer;
  exit;
}


#####################################
# Passwort ndern
#####################################
sub Password {
  print "Content-type: text/html\n\n";
&header;
  print "<CENTER><font face=\"Verdana, Arial\" size=\"2\"><b>Administration - Passwort ndern</b>\n";
  print "<hr width=50% height=2>\n";
  print "<FORM ACTION='$cgiurl?action=password2' METHOD=POST>\n";
  print "<INPUT TYPE=hidden name=\"action2\" value=\"password2\">\n";
  print "<BR>Altes Passwort:<br><INPUT TYPE=password NAME=pass SIZE=10>\n";
  print "<P>Neues Passwort:<br><INPUT TYPE=password NAME=new1 SIZE=10>\n";
  print "<BR>Passwort wiederholen:<br><INPUT TYPE=password NAME=new2 SIZE=10>\n";
  print "<BR><INPUT TYPE=submit NAME=submit VALUE=Enter></font>\n";
  
  print "</FORM>\n";
  &footer;
  exit;
}

sub Password2 {
  &Checkpass;
  &Error("Die beiden neuen Passwrter entsprechen sich nicht") if (param('new1') ne param('new2'));
  &Error("Kein neues Passwort angegeben") unless (param('new1'));

  open(FILE, "$pwdfile");
  &lock(FILE);
    @lines = <FILE>;
  &unlock(FILE);
  close(FILE);

  ($p, $nochop) = split(/``/,$lines[0]);


open (FILE, ">$pwdfile") || &fatal_error("Fehler beim schreiben der Passwortdatei <b>$pwdfile</b>!");
&lock(FILE);

$new = param('new1');

print FILE "$new``xx\n";
  &lock(FILE);
  close (FILE);
print "Content-type: text/html\n\n";
&header;
print "<CENTER><font face=\"Verdana, Arial\" size=\"2\"><b>Administration - Passwort gendert</b>\n";
print "Das Passwort wurde erfolgreich gendert.\n";
print "</font>\n";
&footer;
exit;
}

##########################
# Upload Datei
##########################
sub Upload {
print "Content-type: text/html\n\n";
&header;
  
print "<div align=\"center\">\n";
print "<FORM ACTION=\"$cgiurl?action=upload2\" METHOD=\"POST\" ENCTYPE=\"multipart/form-data\">\n";
print "<INPUT TYPE=hidden name=\"action2\" value=\"upload2\">\n";
print "<table bgcolor=\"#000000\" width=\"550\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\">\n";
print "<tr><td>\n";
print "<table width=\"550\" cellspacing=\"1\" cellpadding=\"2\" border=\"0\">\n";
print "<tr>\n";
print "<td bgcolor=\"#514770\" colspan=\"2\" align=\"center\"><font face=\"Verdana, Arial\" size=\"2\" color=\"#ffffff\"><b>Uploadformular</b></font></td>\n";
print "</tr>\n";
print "<tr>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"190\" align=\"right\"><font face=\"Verdana, Arial\" size=\"2\"><b>Datei: * </b></font></td>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"360\"><input type=\"FILE\" name=\"uploaded_file\" size=\"25\" ACCEPT=\"application/x-zip-compressed\"></td>\n";
print "</tr>\n";
print "<tr>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"190\" align=\"right\"><font face=\"Verdana, Arial\" size=\"2\"><b>Name: * </b></font></td>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"360\"><input type=\"TEXT\" NAME=\"addon_name\" SIZE=\"25\"></td>\n";
print "</tr>\n";
print "<tr>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"190\" align=\"right\"><font face=\"Verdana, Arial\" size=\"2\"><b>Autor: * </b></font></td>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"360\"><INPUT TYPE=\"TEXT\" NAME=\"author\" SIZE=\"25\"></td>\n";
print "</tr>\n";
print "<tr>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"190\" align=\"right\"><font face=\"Verdana, Arial\" size=\"2\"><b>E-Mail: * </b></font></td>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"360\"><INPUT TYPE=\"TEXT\" NAME=\"email\" SIZE=\"25\"></td>\n";
print "</tr>\n";
print "<tr>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"190\" align=\"right\"><font face=\"Verdana, Arial\" size=\"2\"><b>Homepage URL: </b></font></td>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"360\"><INPUT TYPE=\"TEXT\" NAME=\"support_url\" SIZE=\"25\" VALUE=\"http://\"></td>\n";
print "</tr>\n";
print "<tr>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"190\" align=\"right\"><font face=\"Verdana, Arial\" size=\"2\"><b>Kategorie: *</b></font></td>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"360\"><SELECT name=\"file_type\" size=\"1\">\n";
print "  <OPTION VALUE=\"\" name=\"file_type\">----\n";

for ($i=0; $i<@types; $i++) {
($typedir,$typename) = split('#',$types[$i]);
print "<OPTION VALUE=\"$typedir\" name=\"file_type\">$typename\n";
}
print "</SELECT></td></tr>\n";

print "<tr>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"190\" align=\"right\"><font face=\"Verdana, Arial\" size=\"2\"><b>Kurzbeschreibung: *</b></font></td>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"360\"><INPUT TYPE=\"TEXT\" NAME=\"description\" SIZE=\"37\" MAXLENGTH=\"200\"></td>\n";
print "</tr>\n";
print "<tr>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"190\" align=\"right\"><font face=\"Verdana, Arial\" size=\"2\"><b>Readme oder Info: </b></font></td>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"360\"><input type=\"FILE\" name=\"uploaded_info\" size=\"25\"></td>\n";
print "</tr>\n";
print "<tr>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"190\" align=\"right\"><font face=\"Verdana, Arial\" size=\"2\"><b>Screenshot: </b></font></td>\n";
print "<td bgcolor=\"#F0F0F0\" width=\"360\"><input type=\"FILE\" name=\"uploaded_picture\" size=\"25\"></td>\n";
print "</tr>\n";
print "<tr>\n";
print "<td bgcolor=\"#514770\" align=\"center\"><INPUT TYPE=\"SUBMIT\" VALUE=\"Upload\"></td>\n";
print "<td bgcolor=\"#514770\" align=\"center\"><INPUT TYPE=\"RESET\" VALUE=\"Reset\"></td>\n";
print "</tr>\n";
print "<tr>\n";
print "<td bgcolor=\"#F0F0F0\" colspan=\"2\"><font face=\"Verdana, Arial\" size=\"2\"><b>Hilfe: </b></font><br><font face=\"Verdana, Arial\" size=\"1\"><ol>\n";
print "<li><b>Datei</b>, whlen Sie eine Datei von ihrem Computer aus\n";
print "<li><b>Name</b>, geben Sie einen Namen an, z.B. Programm XYZ\n";
print "<li><b>Autor</b>, Ihr oder der Name des Erstellers\n";
print "<li><b>E-Mail</b>, Ihre korrekte Mailadresse\n";
print "<li><b>Homepage URL</b>, Ihre Homepage URL, falls vorhanden\n";
print "<li><b>Kategorie</b>, whlen Sie eine Passende Kategorie aus\n";
print "<li><b>Kurzbeschreibung</b>, geben Sie eine kurze Beschreibung ein, max. 200 Zeichen\n";
print "<li><b>Readme oder Info</b>, hier knnen Sie eine Readme.txt mit hochladen falls vorhanden\n";
print "<li><b>Screenshot</b>, falls Sie einen Screenshot mit hochladen mchte knnen Sie diesen hier auswhlen\n";
print "</font></ol></td>\n";
print "</tr>\n";
print "</tr>\n";
print "</table></td></tr></table>\n";
print "</FORM></div>\n";
&footer;
  exit;
}

sub Upload2 {
  if ($ENV{'REQUEST_METHOD'} eq 'POST')
  {
    $length = "0";
    $length_info = "0";
    $length_pic = "0";
    $length_descriptor = "";
    $filename = param('uploaded_file');
    $pic = param('uploaded_picture');
    $info = param('uploaded_info');
    $type = param('file_type');
    $name = param('addon_name');
    $support = param('support_url');
    if($support eq "http://") {$support = '';}

    if ($type eq '') { &Error("Bitte Auswahl treffen!"); }

    &Send_File;
    &Add_Database;
    exit;
  }
  exit;
}

#############################
## Datei speichern auf Server
#############################
sub Send_File {
  $outfile = lc($filename);
  $upload_dir = "$up_rootdir/$type";
  $picture_upload_dir = "$up_rootdir/$type/pics";
  $info_upload_dir = "$up_rootdir/$type/pics";

  $outfile =~ s {.*[\:\\/]} []gos;
  $outfile =~ s/[^A-Za-z0-9\._ \-=@\x80-\xFE]/_/go;
  $outfile =~ s/-/_/g;
  $outfile =~ s/ /_/g;

  if($outfile !~ /^\w+\.($allowed_files)/) {
      &Error("Nur diese Dateitypen $allowed_files sind erlaubt.");
  }

  if (-e "$up_rootdir/$outfile") { &Error("Dateiname $filename existiert bereits!"); }

  open (OUTPUT,">$upload_dir/$outfile") || &Error("Cannot write to file $upload_dir/$outfile");
  &lock(OUTPUT);
  $time = time;

  binmode(OUTPUT);

  while ($bytes = read($filename,$data,1024))
  {
    $length += $bytes;
    print OUTPUT $data;
  }
  &unlock(OUTPUT);
  close(OUTPUT);

  $koko = int(($length+512)/1024);

  if($koko > $max_size && $max_size > 0) {
        unlink "$upload_dir/$outfile";
        &Error("Dateigre ist limitiert auf ". $max_size/10 ."KB<br>$koko");
  }

  while ($length > 1024 and $length_descriptor ne 'T')
  {
    $length /= 1024;
    $length_descriptor = ($length_descriptor ? ($length_descriptor eq 'K' ?
    'M' : $length_descriptor eq 'M' ? 'G' : 'T' ) : 'K');
  }
  chmod(0666,"$upload_dir/$outfile");

  if ($pic) {&Send_Picture;}
  if ($info) {&Send_Info;}
  return;
}

##################################
# Infodatei speichern
##################################
sub Send_Info {
    $info_outfile = lc($info);
    $info_outfile =~ s {.*[\:\\\/]} []gos;
    $info_outfile =~ s/[^A-Za-z0-9\._ \-=@\x80-\xFE]/_/go;
    $info_outfile =~ s/ /_/g;

    if($info_outfile !~ /^\w+\.($allowed_info)/) {
        &Error("Nur diese Dateitypen $allowed_info sind fr Info Dateien zulssig.");
    }

    if (-e "$info_upload_dir/$info_outfile") { &Error("Datei $info existiert bereits!"); }
	
    if (open INFO,">$info_upload_dir/$info_outfile")
    {
        &lock(INFO);
        while ($bytes = read($info,$data,1024)) {
                $length_info += $bytes;
                print INFO $data;
        }

        $koko = int(($length_info+512)/1024);

        if($koko > $max_size_info && $max_size_info > 0) {
            unlink "$info_upload_dir/$info_outfile";
            &Error("Dateigre ist limitiert auf ". $max_size_info/10 ."KB");
        }
        $info = $info_outfile;
        chmod(0666,"$info_upload_dir/$info_outfile");
        &unlock(INFO);
        close INFO || &Error("Couldn't close files!");
    } else { $info = ''; }
    return;
}
##################################
# Bild speichern
##################################
sub Send_Picture {
    $picture_outfile = lc($pic);
    $picture_outfile =~ s {.*[\:\\\/]} []gos;
    $picture_outfile =~ s/[^A-Za-z0-9\._ \-=@\x80-\xFE]/_/go;
    $picture_outfile =~ s/ /_/g;

    if($picture_outfile !~ /^\w+\.($allowed_pic)/) {
        &Error("Nur diese $allowed_pic Dateitypen sind erlaubt.");
    }

    if (-e "$picture_upload_dir/$picture_outfile") { &Error("Datei $pic existiert bereits!"); }
	
    if (open PICTURE,">$picture_upload_dir/$picture_outfile")
    {
        &lock(PICTURE);
        binmode(PICTURE);
        while ($bytes = read($pic,$data,1024)) {
                $length_pic += $bytes;
                print PICTURE $data;
        }

        $koko = int(($length_pic+512)/1024);

        if($koko > $max_size_info && $max_size_info > 0) {
            unlink "$picture_upload_dir/$picture_outfile";
            &Error("Dateigre ist limitiert auf ". $max_size_info/10 ."KB");
        }
        $pic = $picture_outfile;
        chmod(0666,"$picture_upload_dir/$picture_outfile");
        &unlock(PICTURE);
        close PICTURE || &Error("Couldn't close files!");
    } else { $pic = ''; }
    return;
}


##########################
# Datenbank Eintrag
##########################
sub Add_Database {
    @days = ('Sonntag','Montag','Dienstag','Mittwoch','Donnerstag','Freitag','Samstag');
    @months = ('Januar','Februar','Maerz','April','Mai','Juni','Juli','August','September','Oktober','November','Dezember');

    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($time);

        $mon_num = $mon+1;
#        $hour += '7';
#        $hour -= '24' if ($hour > 24);
        $hour = "0$hour" if ($hour < 10);
        $min = "0$min" if ($min < 10);
        $sec = "0$sec" if ($sec < 10);
        $year = 1900 + $year;

        $xxx3 = substr($months[$mon],0,3);
#        $xxx3 = substr($months[$mon],0,-3);
        $time2 = "$xxx3\. $mday, $year <br> $hour\:$min";


    $data = "\|\|$time\|\|$time2\|\|$name\|\|$type\|\|$outfile\|\|".sprintf("%.0f",$length)."$length_descriptor\|\|".param('author')."\|\|".param('email')."\|\|".param('description')."\|\|0\|\|".($info ? "pics/$info":'')."\|\|".($pic ? "pics/$pic":'')."\|\|$support\|\|";
    

    open (DATABASE,"<$datafile") || &Error("Error reading file: $datafile\n");
    &lock(DATABASE);
      @olddata=<DATABASE>;
    &unlock(DATABASE);
    close(DATABASE);

    open(BAK,">$datafile_$hour-$min-$sec-$year");
    &lock(BAK);
      print BAK @olddata;
    &unlock(BAK);
    close(BAK);

    @newdata = ($data."\n", @olddata);

    open (DATABASE,">$datafile") || &Error("Couldn't append to file: $datafile\n");
      &lock(DATABASE);
      print DATABASE @newdata;
      &unlock(DATABASE);
    close(DATABASE);

# Mail an Admin
open (MAIL, "|$mailprogramm -t") || die $!;
print MAIL "To: $adminemail\n";
print MAIL "From: Upload Datenbank\n";
print MAIL "Subject: Neue Datei hinzugefgt\n\n";
print MAIL "Datei: $name\n";
print MAIL "Dateiname: $outfile\n";
print MAIL "Name: ".param('author')." \n";
print MAIL "E-Mail: ".param('email')."\n";
print MAIL "Beschreibung: ".param('description')."\n";
print MAIL "HP URL: $support\n";
print MAIL "Dateigre: ".sprintf("%.0f",$length)."$length_descriptor\n";
print MAIL "==================================\n\n";


close(MAIL);
	
    print "Content-type: text/html\n\n";
    
    if($header) {
      open(FILE,"<$header") || &Error("$header not found!");
        @header = <FILE>;
      close(FILE);
      $param_type = lc($param_type);
      for($i=0;$i<@header;$i++) {
        $header[$i] =~ s/<!-- type -->//g;
      }
      print @header;
    } else {
      print "<HEAD><META HTTP-EQUIV=\"Refresh\" CONTENT=\"5;URL=$readyurl\"></HEAD>\n";
    }

    print "<CENTER><FONT FACE='Verdana' size='2'><b>Upload erfolgreich!</b><br><br>\n";
    print "Die Datei wurde erfolgreich auf den Server geladen.\n";
    print "<br>\n";

    
    print "</CENTER></FONT>\n";
&footer;

    exit;
}

######################################
# Upload Verzeichnisse anlegen
######################################
sub Makedirs {
  print "Content-type: text/html\n\n";
&header;
  print "<CENTER><font face=\"Verdana, Arial\" size=\"2\"><b>Uploadverzeichnisse anlegen</b><br><br>\n";
  print "<b>Passwort eingeben</b>\n";

  print "<FORM ACTION='$cgiurl?action=makedir2' METHOD=POST>\n";
  print "<INPUT TYPE=hidden name=\"action2\" value=\"makedir2\">\n";
  print "Passwort:<br><INPUT TYPE=password NAME=pass SIZE=10>";
  print "<INPUT TYPE=submit NAME=submit VALUE=Enter>\n";

  
  print "</SPAN>\n";
  &footer;
  exit;
}

sub Makedirs2 {
  &Checkpass;

  print "Content-type: text/html\n\n";
&header;
  print "<CENTER><font face=\"Verdana, Arial\" size=\"2\"><b>Administration - Verzeichnisse erstellt</b>\n";
  print "<br><br>\n";
  print "Folgende Verzeichnisse wurden angelegt:<br>\n";
  print "<UL>";

  for ($i=0; $i<@types; $i++) {
    ($typedir,$typename) = split('#',$types[$i]);
    @tree = split(/\//,$typedir);
    chdir("$up_rootdir");
    for ($y=0; $y<@tree; $y++) {
        mkdir("$tree[$y]",0777);
        chdir("$tree[$y]");
    }
    #mkdir("$up_rootdir/$typedir",0777);
    #mkdir("$up_rootdir/$typedir/pics",0777);
    mkdir("pics",0777);
    print "<LI>$up_rooturl/$typedir\n";
  }
  print "</UL>\n";
  
  print "</SPAN>\n";
  &footer;
  exit;
}

######################################
# Passwort Prfung
######################################
sub Checkpass {
  open(FILE, "$pwdfile") || &Error("Error reading <b>$pwdfile</b>!");
  &lock(FILE);
    @lines = <FILE>;
  &unlock(FILE);
  close(FILE);

  ($p, $nochop) = split(/``/,$lines[0]);


#$p = "upload";
&Error("Kein Passwort oder falsches Passwort") if ($p ne param('pass'));
}
######################################
# Dateilocking
######################################
sub lock {
  local($file)=@_;
  if($flock == 1) {flock($file, $LOCK_EX);}
}

sub unlock {
  local($file)=@_;
  if($flock == 1) {flock($file, $LOCK_UN);}
}


######################################
# Header
######################################
sub header {
open(FILE,"<$header") || &Error("$header not found!");
@header = <FILE>;
close(FILE);
print @header;
}

######################################
# Footer
######################################
sub footer {
open(FILE,"<$footer") || &Error("$footer not found!");
@footer = <FILE>;
close(FILE);
print @footer;
}

######################################
# Fehler
######################################
sub Error {
local($e) = @_;
print "Content-type: text/html\n\n";
&header; 
print "<CENTER><font face=\"Verdana, Arial\" size=\"2\" color=\"#ff0000\"><b>$e</b></font>\n";
&footer;
exit;
}







